unit diagramm;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, TAGraph, TASeries, Forms, Controls, Graphics,
  Dialogs, ActnList, Grids, StdCtrls, ExtCtrls, Getriebe, Motor, fahrzeug, TAChartUtils;

type

  { TF_Diag }

  TF_Diag = class(TForm)
    ButMotor: TButton;
    ButGetriebe: TButton;
    ButFzg: TButton;
    ButDiag: TButton;
    ButDatei: TButton;
    Loeschen: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Speichern: TSaveDialog;
    SimEnde: TLabeledEdit;
    Schritt: TLabeledEdit;
    v_t1: TChart;
    v_t1Line: TLineSeries;
    procedure ButDateiClick(Sender: TObject);
    procedure ButDiagClick(Sender: TObject);
    procedure ButGetriebeClick(Sender: TObject);
    procedure ButMotorClick(Sender: TObject);
    procedure ButFzgClick(Sender: TObject);
    procedure LoeschenClick(Sender: TObject);
    procedure InDatei(var Datei: TextFile);
    procedure v_t1DrawReticule(ASender: TChart; ASeriesIndex, AIndex: Integer;
      const AData: TDoublePoint);

  private
    { private declarations }
  public
    { public declarations }
  end;

const g = 9.81;

var
  F_Diag: TF_Diag;

implementation
uses euler;
{$R *.lfm}

{ TF_Diag }

procedure TF_Diag.ButGetriebeClick(Sender: TObject);
begin
  F_Get.Show;
end;

procedure TF_Diag.ButDiagClick(Sender: TObject);
begin
  EulerEx();
  v_t1.ReticuleMode:=rmCross;
end;

procedure TF_Diag.ButDateiClick(Sender: TObject);
var Datei: TextFile;
  Pfad: String;
begin
  Speichern.Execute;
  Pfad := Speichern.FileName;
  AssignFile(Datei,Pfad);
  Rewrite(Datei);
  InDatei(Datei);
  CloseFile(Datei);
end;

procedure TF_Diag.ButMotorClick(Sender: TObject);
begin
  F_Mot.Show;
end;

procedure TF_Diag.ButFzgClick(Sender: TObject);
begin
  F_Bereif.Show;
end;

procedure TF_Diag.LoeschenClick(Sender: TObject);
begin
  v_t1Line.Clear;
  label1.Caption := 't in [s]';
  label2.Caption := 'v in [km/h]';
  v_t1.ReticuleMode:=rmNone;
end;

procedure TF_Diag.InDatei(var Datei: TextFile);
var
  i, n: Integer;
begin
  n := F_Diag.v_t1Line.Count;
  for i:=0 to n-1 do
  begin
    writeln(Datei,FloatToStrF(F_Diag.v_t1Line.GetXValue(i),ffFixed,5,3),';',FloatToStrF(F_Diag.v_t1Line.GetYValue(i),ffFixed,5,3));
  end;
end;

procedure TF_Diag.v_t1DrawReticule(ASender: TChart; ASeriesIndex,
  AIndex: Integer; const AData: TDoublePoint);
begin
  label1.Caption:=Format('%5.2f',[AData.X]) + ' s';
  label2.Caption:=Format('%5.2f',[AData.Y]) + ' km/h';
end;

end.

