unit getriebe;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, Spin,
  StdCtrls, ValEdit, Grids, ActnList, ExtCtrls;

type

  { TF_Get }

  TF_Get = class(TForm)
    AnzGang: TSpinEdit;
    Button1: TButton;
    CBGet: TCheckBox;
    Label1: TLabel;
    iD: TLabeledEdit;
    GetriebeGrid: TStringGrid;
    procedure AnzGangChange(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure CBGetChange(Sender: TObject);
    procedure Automatik();
    procedure FormClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure GetriebeGridClick(Sender: TObject);
    procedure GetriebeGridEnter(Sender: TObject);
    procedure GetriebeGridMouseLeave(Sender: TObject);
    procedure Uebersetzungen();
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  F_Get: TF_Get;
  iG, tPs, km: array of double;
implementation

{$R *.lfm}

{ TF_Get }

procedure TF_Get.AnzGangChange(Sender: TObject);
begin
GetriebeGrid.RowCount:=AnzGang.Value+1;
end;

procedure TF_Get.Button1Click(Sender: TObject);
begin
  Close();
end;

procedure TF_Get.CBGetChange(Sender: TObject);
var
  i: Integer;
begin
   if CBGet.Checked then Automatik()
   else
     begin
       for i:=0 to High(tPs) do GetriebeGrid.Cells[0,i+1] := FloatToStr(tPs[i]);
       GetriebeGrid.FixedCols:=0;
     end;
end;

procedure TF_Get.Automatik();
var
  i: Integer;
begin
  SetLength(tPs,(GetriebeGrid.RowCount-2));
  for i:=0 to High(tPs) do
      begin
        tPs[i] := StrToFloat(GetriebeGrid.Cells[0,i+1]);
        GetriebeGrid.Cells[0,i+1] := '0,0';
      end;
  GetriebeGrid.FixedCols:=1;
end;

procedure TF_Get.FormClick(Sender: TObject);
begin
  Uebersetzungen();
end;

procedure TF_Get.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
  Uebersetzungen();
end;

procedure TF_Get.FormCreate(Sender: TObject);
begin
  Uebersetzungen();
end;

procedure TF_Get.GetriebeGridClick(Sender: TObject);
begin
  Uebersetzungen();
end;

procedure TF_Get.GetriebeGridEnter(Sender: TObject);
begin
   Uebersetzungen();
end;

procedure TF_Get.GetriebeGridMouseLeave(Sender: TObject);
begin
  Uebersetzungen();
end;

procedure TF_Get.Uebersetzungen();
var
  i: Integer;
  begin
    SetLength(tPs,(GetriebeGrid.RowCount-2));
    SetLength(iG,(GetriebeGrid.RowCount-1));
    SetLength(km,(GetriebeGrid.RowCount-1));
    for i:=0 to High(tPs) do tPs[i] := StrToFloat(GetriebeGrid.Cells[0,i+1]);
    for i:=0 to High(iG) do iG[i] := StrToFloat(GetriebeGrid.Cells[1,i+1]);
    for i:=0 to High(km) do km[i] := StrToFloat(GetriebeGrid.Cells[2,i+1]);
  end;

end.

