unit motor;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, TAGraph, TASeries, TAFuncSeries, Forms, Controls,
  Graphics, Dialogs, Grids, StdCtrls, Spin, ExtCtrls;

type

  { TF_Mot }

  TF_Mot = class(TForm)
    ButBerechne: TButton;
    Button1: TButton;
    GroupBox1: TGroupBox;
    Kennfeld: TChart;
    AnzStuetz: TSpinEdit;
    Leistung: TCubicSplineSeries;
    Moment: TCubicSplineSeries;
    n_Mmax: TLabeledEdit;
    n_Pmax: TLabeledEdit;
    StaticText1: TStaticText;
    KennfeldGrid: TStringGrid;
    procedure AnzStuetzChange(Sender: TObject);
    procedure ButBerechneClick(Sender: TObject);
    procedure BerechneKennfeld();
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  F_Mot: TF_Mot;
implementation

{$R *.lfm}

{ TF_Mot }

procedure TF_Mot.AnzStuetzChange(Sender: TObject);
begin
  KennfeldGrid.RowCount:=AnzStuetz.Value+1        ;
end;

procedure TF_Mot.ButBerechneClick(Sender: TObject);
begin
  BerechneKennfeld();
end;

procedure TF_Mot.FormCreate(Sender: TObject);
begin
  BerechneKennfeld();
end;

procedure TF_Mot.BerechneKennfeld();
var
  i: integer;
  nM, MM, PM: array of double;
begin
  SetLength(nM,KennfeldGrid.RowCount);
  SetLength(MM,KennfeldGrid.RowCount);
  SetLength(PM,KennfeldGrid.RowCount);
  Moment.Clear;
  Leistung.Clear;
  with KennfeldGrid do
  for i:=1 to RowCount - 1 do
    begin
      nM[i]:= StrToFloat(Cells[0,i]);
      MM[i]:= StrToFloat(Cells[1,i]);
      PM[i]:= nM[i]*MM[i]/9550;
      Cells[2,i]:= Format('%8.2f',[PM[i]]);
      Moment.AddXY(nM[i],MM[i]);
      Leistung.AddXY(nM[i],PM[i]);
    end;
end;

procedure TF_Mot.Button1Click(Sender: TObject);
begin
  Close();
end;

end.

